#// Copyright 1998 Christopher Kirmse.  All rights reserved.

#ifndef _DEBUG_H
#define _DEBUG_H

#ifdef CK_ASSERT
#define ck_assert(x) \
do \
{ \
   if (!(x)) \
   { \
      dprintf("Assertion failed (file %s, line %i)\n",__FILE__,__LINE__); \
      __asm { __asm int 3 } \
   } \
} while (0);
#else
#define ck_assert(x)
#endif

#ifdef CK_DPRINTF
#define dprintf app->debug->Printf
#else
#define dprintf
#endif

class Debug
{
public:

   Debug();
   ~Debug();

   void Printf(char *fmt,...);
   
private:

#ifdef CK_DPRINTF

   FILE *f;

#endif
};

#endif
