#// Copyright 1998 Christopher Kirmse.  All rights reserved.

#include "main.h"

char *app_name = "LEDBoard";

HANDLE hPort;

UINT mame32_message;
HANDLE hEvent;
CRITICAL_SECTION cs;

char protected_string[1000];

// this is setup in wm_create
NOTIFYICONDATA nid;
UINT32 taskbar_restart_message;   

char * Interface::color_codes[] =
{
	"<CA>", "<CB>", "<CC>", "<CD>",
	"<CE>", "<CF>", "<CG>", "<CH>",
	"<CI>", "<CJ>", "<CK>", "<CL>",
	"<CM>", "<CN>", "<CO>", "<CP>",
};

char * Interface::function_codes[] =
{
	"<FA>", "<FB>", "<FC>", "<FD>",
	"<FE>", "<FF>", "<FG>", "<FH>",
	"<FI>", "<FJ>", "<FK>", "<FL>",
	"<FM>", "<FN>", "<FO>", "<FP>",
	"<FQ>", "<FR>", "<FS>", "<FT>",
	"<FU>", "<FV>", "<FW>", "<FX>",
	"<FY>", "<FZ>"
};


/***************************************************************/
Interface::Interface()
{
   hMain = NULL;

   WNDCLASS wndclass;
   
   wndclass.style           = CS_HREDRAW | CS_VREDRAW;
   wndclass.lpfnWndProc     = Interface::WindowProc;
   wndclass.cbClsExtra      = 0;
   wndclass.cbWndExtra      = DLGWINDOWEXTRA;
   wndclass.hInstance       = GetModuleHandle(NULL);
   wndclass.hIcon           = LoadIcon(wndclass.hInstance,MAKEINTRESOURCE(IDI_LED_BOARD));
   wndclass.hCursor         = NULL;
   wndclass.hbrBackground   = (HBRUSH)(COLOR_3DFACE + 1);
   wndclass.lpszMenuName    = NULL;
   wndclass.lpszClassName   = app_name;
   
   RegisterClass(&wndclass);

   InitializeCriticalSection(&cs);
   hEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
   _beginthread(WaitStrings,0,NULL);

   hPort = INVALID_HANDLE_VALUE;
   OpenPort("COM2");

   mame32_message = RegisterWindowMessage("MAME32");
   taskbar_restart_message = RegisterWindowMessage("TaskbarCreated");
   
   hMain = CreateDialog(wndclass.hInstance,MAKEINTRESOURCE(IDD_MAIN),0,NULL);

	CheckDlgButton(hMain,IDC_SET_YAHOO_MESSENGER,BST_CHECKED);
	CheckDlgButton(hMain,IDC_PAGINATE,BST_CHECKED);

	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Dim Red");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Red");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Bright Red");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Orange");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Bright Orange");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Light Yellow");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Yellow");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Bright Yellow");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Lime");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Dim Lime");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Bright Lime");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Bright Green");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Green");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Dim Green");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Yellow/Green/Red");
	ComboBox_AddString(GetDlgItem(hMain,IDC_COLOR),"Rainbow");
	ComboBox_SelectString(GetDlgItem(hMain,IDC_COLOR),-1,"Rainbow");



	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Auto");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Open <--->");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Cover <--->");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Appear");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Cycling");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Close <---");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Close --->");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Close --><--");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Scroll Up");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Scroll Down");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Overlap");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Stacking");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Comic 1");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Comic 2");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Beep");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Pause");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Sleep");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Random");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Shift <---");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Time/Date");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Magic");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Thank You");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Welcome");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Speed 1");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Speed 2");
	ComboBox_AddString(GetDlgItem(hMain,IDC_FUNCTION),"Speed 3");
	ComboBox_SelectString(GetDlgItem(hMain,IDC_FUNCTION),-1,"Appear");

	SetMessage(" ");
	Sleep(500);
	SetMessage(" ");
	Sleep(500);
	SetMessage(" ");

}

/***************************************************************/
Interface::~Interface()
{
   Sleep(1000);
   ClearBoard();
   Sleep(1000);
   ClosePort();
}

/***************************************************************/
void Interface::Run()
{
   MSG msg;
   while (GetMessage(&msg,NULL,0,0))
   {
		if (IsDialogMessage(hMain,&msg))
			continue;
      TranslateMessage(&msg);
      DispatchMessage(&msg);
   }
}

/***************************************************************/
HWND Interface::GetAppWindow()
{
   return hMain;
}   

/***************************************************************/
BOOL Interface::On_WM_CREATE(HWND hwnd,LPCREATESTRUCT lpCreateStruct)
{
   app->inter->CreateTrayIcon(hwnd);

   return TRUE;
}

/***************************************************************/
void Interface::On_WM_COMMAND(HWND hwnd,int32 id,HWND hwndCtrl,UINT codeNotify)
{
	if ((id == IDB_SET_MESSAGE && codeNotify == BN_CLICKED) ||
		 (id == IDOK))
	{
		char buffer[1000];
		Edit_GetText(GetDlgItem(hwnd,IDC_TEXT),buffer,sizeof(buffer)-1);
		app->inter->SetMessage(buffer);
		return;
   }

	if (id == IDCANCEL)
	{
		ShowWindow(hwnd,SW_HIDE);
		return;
	}

   if (id == ID_OPEN)
   {
		ShowWindow(app->inter->hMain,SW_SHOW);
		return;
   }

   if (id == ID_CLEAR)
   {
		app->inter->SetMessage("");
		return;
   }

   if (id == ID_EXIT)
   {
		DestroyWindow(hwnd);
		return;
   }

	//dprintf("%i %i\n",id,codeNotify);
}

/***************************************************************/
void Interface::On_CK_TRAY_ICON(HWND hwnd,LPARAM lParam)
{
   switch (lParam)
   {
   case WM_RBUTTONUP :
   {
      HMENU menu;
      menu = LoadMenu(GetModuleHandle(NULL),MAKEINTRESOURCE(IDR_MENU));
      menu = GetSubMenu(menu,0);

      // Make first menu item the default (bold font)
      SetMenuDefaultItem(menu,0,TRUE);

      // Display the menu at the current mouse location. There's a "bug"
      // (Microsoft calls it a feature) in Windows 95 that requires calling
      // SetForegroundWindow. To find out more, search for Q135788 in MSDN.

      POINT mouse;
      GetCursorPos(&mouse);
      SetForegroundWindow(hwnd);
      TrackPopupMenu(menu,0,mouse.x,mouse.y,0,hwnd,NULL);

      break;
   }
      
   case WM_LBUTTONDOWN :
		ShowWindow(hwnd,SW_SHOW);
		SetForegroundWindow(hwnd);
		SetFocus(GetDlgItem(hwnd,IDC_TEXT));
		break;
   default :
      break;
   }
}

#define HANDLE_CK_TRAY_ICON(hwnd,wParam,lParam,fn) ((fn)(hwnd,lParam), 0L)
/***************************************************************/
long WINAPI Interface::WindowProc(HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
   if (message == mame32_message)
   {
      char buffer[500];
      memset(buffer,0,sizeof(buffer));
      GlobalGetAtomName((ATOM)lParam,buffer,sizeof(buffer)-1);
      //dprintf("got message %s\n",buffer);
      app->inter->ReceivedGame(buffer);
      return 1;
   }
   if (message == taskbar_restart_message)
   {
      app->inter->CreateTrayIcon(hwnd);
      return 1;
   }

   switch (message)
   {
      HANDLE_MSG(hwnd,WM_CREATE,Interface::On_WM_CREATE);
      HANDLE_MSG(hwnd,WM_COMMAND,Interface::On_WM_COMMAND);

      HANDLE_MSG(hwnd,CK_TRAY_ICON,Interface::On_CK_TRAY_ICON);

   case WM_CLOSE :
      ShowWindow(app->inter->hMain,SW_HIDE);
      return 0;
      
   case WM_DESTROY:
      Shell_NotifyIcon(NIM_DELETE,&nid);
      app->inter->ClearBoard();
      Sleep(800);
      PostQuitMessage(0);
      break;
      
   }
   
   return DefWindowProc(hwnd,message,wParam,lParam);
}

/***************************************************************/
void Interface::ReceivedGame(char *buffer)
{
	char *cleaned_string = GetCleanedString(buffer);

	Edit_SetText(GetDlgItem(hMain,IDC_TEXT),cleaned_string);

	SetMessage(cleaned_string);
}
/***************************************************************/
void Interface::SetMessage(char *buffer)
{
   ck_assert(buffer != NULL);
	char coded_string[1500];

	if (IsDlgButtonChecked(hMain,IDC_SET_YAHOO_MESSENGER))
		SetYahooMessengerStatus(buffer);

   Edit_SetText(GetDlgItem(hMain,IDC_GAME),buffer);

	if (IsDlgButtonChecked(hMain,IDC_PAGINATE))
	{
		if (strlen(buffer) > 12)
		{
			buffer = GetPaginatedString(buffer,function_codes[ComboBox_GetCurSel(GetDlgItem(hMain,IDC_FUNCTION))]);
		}
	}
	sprintf(coded_string,"%s%s%s",
			  color_codes[ComboBox_GetCurSel(GetDlgItem(hMain,IDC_COLOR))],
			  function_codes[ComboBox_GetCurSel(GetDlgItem(hMain,IDC_FUNCTION))],
			  buffer);
	
   WritePage(coded_string);
}

/***************************************************************/
void Interface::OpenPort(char *port_name)
{
   hPort = CreateFile(port_name,GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
   if (hPort == INVALID_HANDLE_VALUE)
   {
      dprintf("Unable to open com port %s\n",port_name);
      return;
   }
   
   DCB dcb;
   if (GetCommState(hPort,&dcb) == FALSE)
   {
      dprintf("error getting comm state\n");
      return;
   }
	dprintf("%u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u\n",
			  dcb.DCBlength,dcb.BaudRate,dcb.fBinary,dcb.fParity,
			  dcb.fOutxCtsFlow,dcb.fOutxDsrFlow,dcb.fDtrControl,
			  dcb.fDsrSensitivity,dcb.fTXContinueOnXoff,dcb.fOutX,
			  dcb.fInX,dcb.fErrorChar,dcb.fNull,dcb.fRtsControl,
			  dcb.fAbortOnError,dcb.fDummy2,dcb.wReserved,dcb.XonLim,
			  dcb.XoffLim,dcb.ByteSize,dcb.Parity,dcb.StopBits);
	if (dcb.fDsrSensitivity != FALSE)
		dprintf("disabling dsr\n");
	if (dcb.fOutX != FALSE)
		dprintf("disabling outx\n");
	if (dcb.fInX != FALSE)
		dprintf("disabling inx\n");
	if (dcb.fRtsControl != RTS_CONTROL_DISABLE)
		dprintf("disabling rts control\n");
	if (dcb.fOutxCtsFlow != FALSE)
		dprintf("disabling outx cts\n");
	if (dcb.fOutxDsrFlow != FALSE)
		dprintf("disabling outx dsr\n");
	if (dcb.fDtrControl != DTR_CONTROL_DISABLE)
		dprintf("disabling dtr\n");
	if (dcb.fTXContinueOnXoff != 1)
		dprintf("enabling txcontinue on xoff\n");
	if (dcb.fAbortOnError != 1)
		dprintf("enabling abort on error\n");
	if (dcb.ByteSize != 8)
		dprintf("setting 8 bits per byte\n");

	dcb.BaudRate = CBR_300;

	dcb.fDsrSensitivity = FALSE;
	dcb.fOutX = FALSE;
	dcb.fInX = FALSE;
	dcb.fRtsControl = RTS_CONTROL_DISABLE;
	dcb.fOutxCtsFlow = FALSE;
	dcb.fOutxDsrFlow = FALSE;
	dcb.fDtrControl = DTR_CONTROL_DISABLE;

	dcb.fTXContinueOnXoff = 1;
	dcb.fAbortOnError = 1;
	dcb.ByteSize = 8;


	if (SetCommState(hPort,&dcb) == FALSE)
	{
		dprintf("error setting comm state\n");
		return;
	}

	COMMTIMEOUTS comm_timeouts;
	comm_timeouts.ReadIntervalTimeout = 80; // 80ms between chars ok
	comm_timeouts.ReadTotalTimeoutMultiplier = 40; // 40ms per char total
	comm_timeouts.ReadTotalTimeoutConstant = 900; // wait at least 900ms
	comm_timeouts.WriteTotalTimeoutMultiplier = 40; // 40ms per char total
	comm_timeouts.WriteTotalTimeoutConstant = 300; // wait at least 300ms

	if (SetCommTimeouts(hPort,&comm_timeouts) == FALSE)
	{
		dprintf("error setting comm timeouts\n");
		return;
	}

   ClearBoard();
}

/***************************************************************/
void Interface::ClosePort()
{
   if (hPort != INVALID_HANDLE_VALUE)
   {
      CloseHandle(hPort);
      hPort = INVALID_HANDLE_VALUE;
   }
}

/***************************************************************/
void Interface::ClearBoard()
{
   WritePage(" ");
}

/***************************************************************/
void Interface::WritePage(char *s)
{
   EnterCriticalSection(&cs);
   strcpy(protected_string,s);
   LeaveCriticalSection(&cs);
   SetEvent(hEvent);

}

/***************************************************************/
char * Interface::GetCleanedString(char *game)
{
   static char buffer[1500];
   char *ptr;

   // make a first pass to cut off extraneous junk (started by slashes or parentheses)
   ptr = buffer;
   while (*game != 0)
   {
      if (*game == ' ' && (*(game+1) == '/' || *(game+1) == '('))
			break;
		*ptr = *game;
		ptr++;
		game++;
	}
	*ptr = 0;
	return buffer;
}

/***************************************************************/
char * Interface::GetPaginatedString(char *game,char *page_text)
{
   static char buffer[1500];

	int page_count = 0;
   char *ptr = buffer;
	char *most_recent_space = game;
	char *prev_page = game;
	int count = 0;
   while (true)
   {
		if (isspace(*game))
			most_recent_space = game;

		count++;
		if (count >= 12 || *game == 0)
		{
			if (page_count > 0)
			{
				memcpy(ptr,page_text,strlen(page_text));
				ptr += strlen(page_text);
			}
			page_count++;
			if (most_recent_space == prev_page)
				most_recent_space = game;

			while (prev_page != most_recent_space)
			{
				*ptr = *prev_page;
				ptr++;
				prev_page++;
			}

			// skip over the spaces since we're on a new page anyway
			while (*most_recent_space != 0 &&
					 isspace(*most_recent_space))
				most_recent_space++;

			prev_page = game = most_recent_space;
			count = 0;
		}
		if (*game == 0)
			break;
		game++;
	};

	*ptr = 0;
	return buffer;
}

/***************************************************************/
void Interface::Write(char *fmt,...)
{
   if (hPort == INVALID_HANDLE_VALUE)
      return;

   va_list marker;
   char buffer[2000];

   va_start(marker,fmt);
   vsprintf(buffer,fmt,marker);
   va_end(marker);

   dprintf("writing string to board: %s\n",buffer);

   DWORD written;
   if (WriteFile(hPort,buffer,strlen(buffer),&written,NULL) == FALSE)
   {
      dprintf("error writing to com port\n");
   }

}

/***************************************************************/
bool Interface::ReadResponse()
{
	if (hPort == INVALID_HANDLE_VALUE)
		return true;

	//dprintf("start read\n");
	char buffer[2000];
	DWORD read;
	if (ReadFile(hPort,buffer,8,&read,NULL) == FALSE)
	{
		dprintf("error reading com port\n");
	}
	buffer[read] = 0;
	dprintf("Read %i bytes: [%s]\n",read,buffer);
	if (strcmp(buffer,"<ID01>\r\n") == 0)
		return true;

	return false;
}

// courtesy brian gottlieb
/***************************************************************/
void Interface::SetYahooMessengerStatus(char *buffer)
{
   HKEY msgReg;

   DWORD retCode;
 
   retCode = RegOpenKeyEx (HKEY_CURRENT_USER,
                           "Software\\Yahoo\\Pager",
                           0,           // Reserved.
                           KEY_EXECUTE, // Requesting read access.
                           &msgReg);      // Address of key to be returned.
   
   if (retCode != ERROR_SUCCESS)
      return;

   HKEY uKey;
   DWORD type;
   char username[200];
   DWORD unlen = 200;
   int i, j;
   char mystr[53];
  
   if (strlen(buffer) == 0)
      buffer = " ";
 
   for(i=0, j=0; buffer[i] && j<52; i++) {
      if (buffer[i] >=32) {
         mystr[j++] = buffer[i];
      }
   }
   mystr[j] = '\0';
   
   retCode = RegQueryValueEx(msgReg,
                             "Yahoo! User ID",
                             0,
                             &type,
                             (byte *)username,
                             &unlen);
   
   if (retCode == ERROR_SUCCESS)
   {
      char upath[225];
      
      sprintf(upath, "profiles\\%s\\Custom Msgs", username);
      
      retCode = RegOpenKeyEx (msgReg,
			      upath,
			      0,
			      KEY_WRITE|KEY_READ,
			      &uKey);
      if (retCode == ERROR_SUCCESS)
      {
         int custNum;
         char custStr[2];
         
         for (custNum = 5; custNum > 0; custNum--)
         {
            char tbuf[255];
            unsigned long tlen;
            sprintf(custStr, "%d", custNum);
            
            retCode = RegQueryValueEx(msgReg,
                                      custStr,
                                      0,
                                      &type,
                                      (byte *)tbuf,
                                      &tlen);
            
            if (retCode == ERROR_SUCCESS)
            {
               if (strchr(tbuf, '-') != NULL)
               {
                  break;
               }
            }
         }
         
         if (custNum == 0)
         {
            custNum = 5;
            strcpy(custStr, "5");
         }
         
         retCode = RegSetValueEx (uKey,
                                  custStr,
                                  0,
                                  REG_SZ,
                                  (byte *)mystr,
                                  strlen(mystr));
         if (retCode == ERROR_SUCCESS)
         {
				HWND ym_wnd = FindWindow("YahooBuddyMain",NULL);
				if (ym_wnd != NULL)
				{
					WPARAM wp = MAKEWPARAM(387 + custNum,0);
					PostMessage(ym_wnd, WM_COMMAND, wp, 0);
				}
         }
         
         retCode = RegCloseKey(uKey);
      }
   }
   RegCloseKey(msgReg);
}

// this runs in a separate thread
/***************************************************************/
void Interface::WaitStrings(void *dummy)
{
	int current_page = 0;

	while (1)
	{
		WaitForSingleObject(hEvent,INFINITE);

		char buffer[2000];
		sprintf(buffer,"\r\n\r\n<ID01><P%c>%s\r\n",'A' + current_page,protected_string);

		do
		{
			app->inter->Write(buffer);
		} while (app->inter->ReadResponse() == false);

		sprintf(buffer,"<ID01><RP%c>\r\n",'A' + current_page);

		do
		{
			app->inter->Write(buffer);
		} while (app->inter->ReadResponse() == false);

		current_page = (current_page + 1) % 10;


   }
}

/***************************************************************/
void Interface::CreateTrayIcon(HWND hwnd)
{
   memset(&nid,0,sizeof(nid));
   nid.cbSize = sizeof(nid);
   nid.hWnd = hwnd;
   nid.uID = 0;
   nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
   nid.uCallbackMessage = CK_TRAY_ICON;
   //nid.hIcon = LoadIcon(GetModuleHandle(NULL),MAKEINTRESOURCE(IDI_LED_BOARD));
   nid.hIcon = LoadImage(GetModuleHandle(NULL),MAKEINTRESOURCE(IDI_LED_BOARD),IMAGE_ICON,
                         16,16,LR_DEFAULTCOLOR);
   strcpy(nid.szTip,"LED Board Controller");

   Shell_NotifyIcon(NIM_ADD,&nid);
}
