#// Copyright 1998 Christopher Kirmse.  All rights reserved.

#ifndef _INTERFACE_H
#define _INTERFACE_H

#define CK_TRAY_ICON (WM_APP + 1)

class Interface
{
public:

   Interface();
   ~Interface();

   void Run();

   HWND GetAppWindow();

   static BOOL On_WM_CREATE(HWND hwnd,LPCREATESTRUCT lpCreateStruct);
   static void On_WM_COMMAND(HWND hwnd,int32 id,HWND hwndCtrl,UINT codeNotify);
   static void On_CK_TRAY_ICON(HWND hwnd,LPARAM lParam);

   static long WINAPI WindowProc(HWND hwnd,UINT message,UINT wParam,LONG lParam);

private:

   static char * color_codes[];
   static char * function_codes[];

   HWND hMain;

   void ReceivedGame(char *buffer);
   void SetMessage(char *buffer);

   void OpenPort(char *port_name);
   void ClosePort();

   void ClearBoard();
   void WritePage(char *s);
   static char * GetCleanedString(char *game);
   static char * GetPaginatedString(char *game,char *page_text);
   void Write(char *fmt,...);
   bool ReadResponse();

   void SetYahooMessengerStatus(char *buffer);

   static void WaitStrings(void *dummy);
   

   void CreateTrayIcon(HWND hwnd);
};
   
#endif

